# Self-supervised contrastive learning performs non-linear system identification

[[website](https://dynamical-inference.ai/dyncl)] [[pre-print](/#)]

This repo contains the code for the `DynCL` algorithm presented in "Self-supervised contrastive learning performs non-linear system identification".

**We will open source the code upon publication of our pre-print**. Stay tuned!
If you want to get notified about the code release, make sure to `watch 🕶️` the repo!
In case you need early access to the codebase (for benchmarking/comparisons, application of DynCL to a dataset, etc.), please send an email to [Steffen Schneider](mailto:steffen.schneider@helmholtz-munich.de).

## Summary

Self-supervised learning (SSL) approaches have brought tremendous success across many tasks and domains. It has been argued that these successes can be attributed to a link between SSL and identifiable representation learning: Temporal structure and auxiliary variables ensure that latent representations are related to the true underlying generative factors of the data. Here, we deepen this connection and show that SSL can perform system identification in latent space. We propose a new model to uncover linear, switching linear and non-linear dynamics under a non-linear observation model, give theoretical guarantees and validate them empirically.

<img width="840" alt="image" src="https://github.com/user-attachments/assets/6cb94bd0-2f24-4164-ae7c-353c4d8554ba">

<img width="858" alt="image" src="https://github.com/user-attachments/assets/ede39332-4b8a-4728-9a23-8983c0534d68">

## Reference

```
@article{gozalezlaizschmidt2024dyncl,
  author = {González Laiz, Rodrigo and Schmidt, Tobias and Schneider, Steffen},
  title={Self-supervised contrastive learning performs non-linear system identification},
  journal={CoRR},
  year={2024},
  month={October},
  url={/#}
}
```
